/* k8basic 2023-09-14 */
CREATE TABLE `k8login` (
	`userID` INT(10) NOT NULL AUTO_INCREMENT,
	`clientID` INT(10) NOT NULL,
	`username` VARCHAR(50) NOT NULL,
	`email` VARCHAR(100) NOT NULL,
	`password` VARCHAR(50) NOT NULL,
	`title` VARCHAR(10) NULL DEFAULT NULL,
	`firstname` VARCHAR(50) NULL DEFAULT NULL,
	`lastname` VARCHAR(50) NULL DEFAULT NULL,
	`active` TINYINT(4) NOT NULL,
	`roleID` INT(11) NOT NULL,
	`roles` VARCHAR(255) NOT NULL,
	`settings` TEXT NOT NULL,
	`rightgroupIDdefault` INT(11) NOT NULL,
	`datetimecreated` DATETIME NOT NULL,
	`creatorID` INT(10) NOT NULL,
	PRIMARY KEY (`userID`),
	UNIQUE INDEX `username` (`username`)
);
INSERT INTO `k8login` (`clientID`, `username`, `email`, `password`, `active`, `roles`,`creatorID`) 
VALUES (1, 'admin', 'xy@gmail.com', 'admin', 1, '2', 4);
INSERT INTO `k8login` (`userID`, `clientID`, `username`, `email`, `password`, `active`, `roles`,`creatorID`) 
VALUES (0, 'superuser', 'xx@gmail.com', 'superuser', 1, '2', 4);

CREATE TABLE `k8loginfriends` (
	`ID` INT(10) NOT NULL AUTO_INCREMENT,
	`clientID` INT(10) NULL DEFAULT NULL,
	`userID` INT(10) NULL DEFAULT NULL,
	`friendID` INT(10) NULL DEFAULT NULL,
	`roleID` INT(10) NULL DEFAULT NULL,
	`usergroupID` INT(10) NULL DEFAULT NULL,
	PRIMARY KEY (`ID`)
);

CREATE TABLE `k8references` (
	`clientID` INT(10) NULL DEFAULT '0',
	`ID` INT(10) NOT NULL AUTO_INCREMENT,
	`basetype` VARCHAR(50) NULL DEFAULT NULL,
	`baseID` INT(10) NULL DEFAULT '0',
	`marking` VARCHAR(50) NULL DEFAULT NULL,
	`type` VARCHAR(50) NULL DEFAULT NULL,
	`title` VARCHAR(50) NULL DEFAULT NULL,
	`description` TEXT NULL,
	`descriptionlarge` TEXT NULL,
	`path` VARCHAR(255) NULL DEFAULT NULL,
	`filename` VARCHAR(255) NULL DEFAULT NULL,
	`filetype` VARCHAR(50) NULL DEFAULT NULL,
	`height` INT(10) NULL DEFAULT '0',
	`width` INT(10) NULL DEFAULT '0',
	`duration` DOUBLE NULL DEFAULT '0',
	`creatorID` INT(10) NULL DEFAULT '0',
	`datecreated` DATETIME NULL DEFAULT NULL,
	`ready` TINYINT(4) NULL DEFAULT '0',
	`checked` INT(11) NULL DEFAULT '0',
	`sort` INT(11) NULL DEFAULT '0',
	`points` SMALLINT(6) NULL DEFAULT NULL,
	`language` INT(11) NULL DEFAULT '0',
	`childID` INT(11) NULL DEFAULT '0',
	`latitude` DOUBLE NULL DEFAULT '0',
	`longitude` DOUBLE NULL DEFAULT '0',
	`copyright` VARCHAR(500) NULL DEFAULT NULL,
	`mydatetime` DATETIME NULL DEFAULT NULL,
	`addressline` VARCHAR(255) NULL DEFAULT NULL,
	PRIMARY KEY (`ID`)
);

CREATE TABLE `k8languages` (
	`ID` INT(10) NOT NULL AUTO_INCREMENT,
	`pk` INT(10) NULL DEFAULT NULL,
	`languageID` INT(10) NOT NULL,
	`module` VARCHAR(50) NOT NULL,
	`key` VARCHAR(50) NOT NULL,
	`value` TEXT NULL DEFAULT NULL,
	PRIMARY KEY (`ID`),
	INDEX `lang_mod_key` (`pk`, `languageID`, `module`, `key`)
);

CREATE TABLE `k8menuentries` (
	`IDentry` INT(10) NOT NULL AUTO_INCREMENT,
	`parentID` INT(10) NULL DEFAULT NULL,
	`sort` FLOAT NULL DEFAULT NULL,
	`ID` INT(10) NULL DEFAULT NULL,
	`mypage` VARCHAR(50) NULL DEFAULT NULL,
	`activeby` VARCHAR(50) NULL DEFAULT NULL,
	`href` VARCHAR(254) NULL DEFAULT NULL,
	`target` VARCHAR(50) NULL DEFAULT NULL,
	`title` VARCHAR(50) NULL DEFAULT NULL,
	`condition` VARCHAR(254) NULL DEFAULT NULL,
	`li_attributes` VARCHAR(254) NULL DEFAULT NULL,
	`a_attributes` VARCHAR(254) NULL DEFAULT NULL,
	PRIMARY KEY (`IDentry`)
);

CREATE TABLE `k8pages` (
	`pageID` INT(10) NOT NULL AUTO_INCREMENT,
	`titleID` INT(10) NOT NULL,
	`clientID` INT(10) NOT NULL,
	`parentID` INT(11) NOT NULL,
	`groupID` INT(11) NULL DEFAULT NULL,
	`sort` INT(10) NOT NULL,
	`language` INT(11) NOT NULL,
	`marking` VARCHAR(50) NOT NULL,
	`headtitle` VARCHAR(255) NULL DEFAULT NULL,
	`headdescription` VARCHAR(255) NULL DEFAULT NULL,
	`headkeywords` VARCHAR(255) NULL DEFAULT NULL,
	`head` TEXT NULL DEFAULT NULL,
	`h1` VARCHAR(255) NULL DEFAULT NULL,
	`content` TEXT NULL DEFAULT NULL,
	`site` TEXT NULL DEFAULT NULL,
	`foot` TEXT NULL DEFAULT NULL,
	`active` TINYINT(4) NULL DEFAULT NULL,
	`pageIDprevious` INT(11) NULL DEFAULT NULL,
	`pageIDnext` INT(11) NULL DEFAULT NULL,
	`datetimechanged` DATETIME NULL DEFAULT NULL,
	`datetimecreated` DATETIME NULL DEFAULT NULL,
	`creatorID` INT(11) NULL DEFAULT NULL,
	PRIMARY KEY (`pageID`),
	UNIQUE INDEX `marking` (`marking`)
);

CREATE TABLE `k8clients` (
	`clientID` INT(10) NOT NULL AUTO_INCREMENT,
	`name` VARCHAR(60) NULL DEFAULT NULL,
	`description` TEXT NULL DEFAULT NULL,
	`datetimecreated` DATETIME NULL DEFAULT NULL,
	`creatorID` INT(11) NULL DEFAULT NULL,
	PRIMARY KEY (`clientID`),
	UNIQUE INDEX `Name` (`name`)
);

CREATE TABLE `k8rightgroups` (
	`rightgroupID` INT(10) NOT NULL AUTO_INCREMENT,
	`name` VARCHAR(50) NOT NULL,
	`description` TEXT NULL DEFAULT NULL,
	`datecreated` DATE NOT NULL,
	`creatorID` INT(10) NOT NULL,
	PRIMARY KEY (`rightgroupID`),
	UNIQUE INDEX `Name` (`name`)
);

CREATE TABLE `k8rightmembers` (
	`ID` INT(10) NOT NULL AUTO_INCREMENT,
	`rightgroupID` INT(10) NOT NULL,
	`status` TINYINT(4) NOT NULL,
	`userID` INT(10) NOT NULL,
	PRIMARY KEY (`ID`),
	UNIQUE INDEX `rightgroup_user` (`rightgroupID`, `userID`)
)

REPLACE INTO `k8pages` (`pageID`, `titleID`, `clientID`, `parentID`, `groupID`, `sort`, `language`, `marking`, `headtitle`, `headdescription`, `headkeywords`, `head`, `h1`, `content`, `site`, `foot`, `active`, `pageIDprevious`, `pageIDnext`, `datetimechanged`, `datetimecreated`, `creatorID`) VALUES (26, 0, 0, 0, NULL, 0, 0, 'privacypolicy', 'Privacy Policy', 'This is the privacy policy', 'privacy policy', '', 'Privacy Policy', '<p>Please enter your privacy policy here.</p>', '', '', NULL, NULL, NULL, NULL, '2021-07-30 11:43:33', 1);
REPLACE INTO `k8pages` (`pageID`, `titleID`, `clientID`, `parentID`, `groupID`, `sort`, `language`, `marking`, `headtitle`, `headdescription`, `headkeywords`, `head`, `h1`, `content`, `site`, `foot`, `active`, `pageIDprevious`, `pageIDnext`, `datetimechanged`, `datetimecreated`, `creatorID`) VALUES (28, 0, 0, 0, NULL, 0, 0, 'termsofuse', 'Terms of Use', 'This are our terms of uye.', 'terms of use', '', 'Terms of Use', '<p>Please enter the terms of use here.</p>', '', '', NULL, NULL, NULL, NULL, '2024-03-18 17:36:13', 1);
